ant = {}
local am = {__index = ant}

function ant.new(x, y, color)
	local a = {
			x = x,
			y = y,
			direction = love.math.random(1, 4),-- 1 = UP, 2 = RIGHT...
			color = color
		}
	return setmetatable(a, am)
end

function ant:step()
	local cell = sim.map:getCell(self.x, self.y)
	if map_cells[cell].direction == "l" then
		self.direction = self.direction - 1
		if self.direction < 1 then self.direction = 4 end
		sim.map:setCell(self.x, self.y, cell + 1)
		self:move()
	elseif map_cells[cell].direction == "r" then
		self.direction = self.direction + 1
		if self.direction > 4 then self.direction = 1 end
		sim.map:setCell(self.x, self.y, cell + 1)
		self:move()
	elseif map_cells[cell].direction == "n" then
		sim.map:setCell(self.x, self.y, cell + 1)
		self:move()
	end
end

function ant:move()
	local nx, ny = self.x, self.y
	if self.direction == 1 then
		ny = ny - 1
	elseif self.direction == 2 then
		nx = nx + 1
	elseif self.direction == 3 then
		ny = ny + 1
	elseif self.direction == 4 then
		nx = nx - 1
	end
	
	--Wall Wrapping
	if nx < 0 then 
		nx = 0 
		self.direction = 2
	elseif nx > sim.map_width-1 then 
		nx = sim.map_width-1 
		self.direction = 4
	end
	
	if ny < 0 then 
		ny = 0 
		self.direction = 3
	elseif ny > sim.map_height-1 then 
		ny = sim.map_height-1 
		self.direction = 1
	end
	
	self.x, self.y = nx, ny
end
--[[
local a = ants[i]
	local nx, ny = a.x, a.y
	if a.d == 1 then
		nx = nx + 1
	elseif a.d == 2 then
		ny = ny + 1
	elseif a.d == 3 then
		nx = nx - 1
	elseif a.d == 4 then
		ny = ny - 1
	end	
	
	--"collision"
	if nx < 0 then nx = map_width-1 elseif nx > map_width-1 then nx = 1 end
	if ny < 0 then ny = map_height-1 elseif ny > map_height-1 then ny = 1 end
	
	ants[i].x, ants[i].y = nx, ny
]]
function ant:draw()
	love.graphics.setColor(hsl(self.color, 128, 200))
	--love.graphics.rectangle("fill", self.x * sim.map_cellSize, self.y * sim.map_cellSize, sim.map_cellSize, sim.map_cellSize)
	love.graphics.circle("fill", self.x * sim.map_cellSize, self.y * sim.map_cellSize, sim.map_cellSize / 2)
end