screen = {
		width = love.graphics.getWidth(),
		height = love.graphics.getHeight()
	}

sim = {
		running = false,
		speed = 60, --Steps per second
		tick = 0,
		map = {},
		ants = {},
		map_width = 200,
		map_height = 200,
		map_cellSize = 4,
		steps = 0
	}

--Loading Files
require "ant"
require "map"

	
function love.load()
	sim.map = map.new(sim.map_width, sim.map_height, sim.map_cellSize)
	love.window.setMode(sim.map_width * sim.map_cellSize, sim.map_height * sim.map_cellSize)
	
	sim.ants[#sim.ants + 1] = ant.new(math.floor(sim.map_width / 2), math.floor(sim.map_height / 2), 0)
	love.timer.step()
end

function love.update(dt)
	if sim.running then
		sim.tick = sim.tick + dt
		if sim.tick > (1 / sim.speed) then
			for i,v in ipairs(sim.ants) do
				v:step()
			end
			sim.steps = sim.steps + 1
			tick = 0
		end
	end
	
	love.window.setTitle("Langton's Ant ["..love.timer.getFPS().."]")
end

function love.draw()
	love.graphics.setColor(255, 255, 255, 255)
	sim.map:draw()
	--ants
	for i,v in ipairs(sim.ants) do
		v:draw()
	end
	
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.print(sim.steps, 12, 12)
end

function love.keypressed(key)
	if key == "escape" then love.event.push("quit") end
	if key == " " then sim.running = not sim.running end
end

function love.mousepressed(x, y, key)
	local gx = math.floor(x / sim.map_cellSize)
	local gy = math.floor(y / sim.map_cellSize)
	sim.ants[#sim.ants + 1] = ant.new(gx, gy, love.math.random(255))
end

function hsl(h, s, l, a)
	if type(h) == "table" then
		h,s,l,a = h[1], h[2], h[3], h[4] or 255
	end
    if s<=0 then return l,l,l,a end
    h, s, l = h/256*6, s/255, l/255
    local c = (1-math.abs(2*l-1))*s
    local x = (1-math.abs(h%2-1))*c
    local m,r,g,b = (l-.5*c), 0,0,0
    if h < 1     then r,g,b = c,x,0
    elseif h < 2 then r,g,b = x,c,0
    elseif h < 3 then r,g,b = 0,c,x
    elseif h < 4 then r,g,b = 0,x,c
    elseif h < 5 then r,g,b = x,0,c
    else              r,g,b = c,0,x
    end return (r+m)*255,(g+m)*255,(b+m)*255,a
end
