map = {}
local mm = {__index = map}

local pat = {"r", "l"} --r, l, n

map_cells = {}
for i,v in ipairs(pat) do
	map_cells[#map_cells + 1] = {
			color = {(255 / #pat) * i, 126, 126},
			direction = v
		}
end

	
local map_width, map_height, map_cellSize = 0, 0, 0

function map.new(width, height, cell_size)
	local c = {}
	map_width, map_height, map_cellSize = width, height, cell_size
	for y=0, height-1 do
		c[y] = {}
		for x=0, width-1 do
			c[y][x] = 1
		end
	end
	
	return setmetatable(c, mm)
end

--CALLBACKS
function map:update(dt)

end

function map:draw()
	for y=0, map_height-1 do
		for x=0, map_width-1 do
			local cell = self:getCell(x, y)
			if cell > 1 then
				love.graphics.setColor(hsl(map_cells[cell].color))
				--love.graphics.rectangle("fill", x * map_cellSize, y * map_cellSize, map_cellSize, map_cellSize)
				love.graphics.circle("fill", x * map_cellSize, y * map_cellSize, map_cellSize / 2)
			end
		end
	end
end

--CELL METHODS
function map:getTypes()
	return #map_cells
end

function map:setCell(x, y, cell)
	if cell > #map_cells then cell = 1 end
	self[y][x] = cell
end

function map:getCell(x, y)
	--if x > 0 and x < map_width-2 and y > 0 and y < map_height-2 then
			return self[y][x]
	--end
end

function map:exists(x, y)
	if self[y][x] ~= nil then return true else return false end
end

